# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class DetectedIssueSeverity(str, enum.Enum):
    """
    Indicates the degree of importance associated with the identified issue based on the potential impact on the patient.
    """

    HIGH = "high"
    MODERATE = "moderate"
    LOW = "low"

    def visit(
        self,
        high: typing.Callable[[], T_Result],
        moderate: typing.Callable[[], T_Result],
        low: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is DetectedIssueSeverity.HIGH:
            return high()
        if self is DetectedIssueSeverity.MODERATE:
            return moderate()
        if self is DetectedIssueSeverity.LOW:
            return low()
