# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class DeviceMetricCategory(str, enum.Enum):
    """
    Indicates the category of the observation generation process. A DeviceMetric can be for example a setting, measurement, or calculation.
    """

    MEASUREMENT = "measurement"
    SETTING = "setting"
    CALCULATION = "calculation"
    UNSPECIFIED = "unspecified"

    def visit(
        self,
        measurement: typing.Callable[[], T_Result],
        setting: typing.Callable[[], T_Result],
        calculation: typing.Callable[[], T_Result],
        unspecified: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is DeviceMetricCategory.MEASUREMENT:
            return measurement()
        if self is DeviceMetricCategory.SETTING:
            return setting()
        if self is DeviceMetricCategory.CALCULATION:
            return calculation()
        if self is DeviceMetricCategory.UNSPECIFIED:
            return unspecified()
