# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class MessageDefinitionCategory(str, enum.Enum):
    """
    The impact of the content of the message.
    """

    CONSEQUENCE = "consequence"
    CURRENCY = "currency"
    NOTIFICATION = "notification"

    def visit(
        self,
        consequence: typing.Callable[[], T_Result],
        currency: typing.Callable[[], T_Result],
        notification: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is MessageDefinitionCategory.CONSEQUENCE:
            return consequence()
        if self is MessageDefinitionCategory.CURRENCY:
            return currency()
        if self is MessageDefinitionCategory.NOTIFICATION:
            return notification()
