# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class MolecularSequenceReferenceSeqStrand(str, enum.Enum):
    """
    An absolute reference to a strand. The Watson strand is the strand whose 5'-end is on the short arm of the chromosome, and the Crick strand as the one whose 5'-end is on the long arm.
    """

    WATSON = "watson"
    CRICK = "crick"

    def visit(self, watson: typing.Callable[[], T_Result], crick: typing.Callable[[], T_Result]) -> T_Result:
        if self is MolecularSequenceReferenceSeqStrand.WATSON:
            return watson()
        if self is MolecularSequenceReferenceSeqStrand.CRICK:
            return crick()
