# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Contact(pydantic.BaseModel):
    """
    from metriport.medical import Contact

    Contact(
        phone="1234567899",
        email="karen@cvspharmacy.com",
    )
    """

    phone: typing.Optional[str] = pydantic.Field(
        default=None, description="The Patient's 10 digit phone number, formatted `1234567899`."
    )
    email: typing.Optional[str] = pydantic.Field(default=None, description="The Patient's email address.")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
